/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Contents of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.96 - (hide annotations) (download)
Thu Apr 1 10:12:36 2010 UTC (4 years, 3 months ago) by flameeyes
Branch: MAIN
Changes since 1.95: +14 -11 lines
Try to unbreak revision 1.95, at least guessing what Robin tried to do.

1 vapier 1.91 # Copyright 1999-2010 Gentoo Foundation
2 vapier 1.6 # Distributed under the terms of the GNU General Public License v2
3 flameeyes 1.96 # $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.95 2010/03/31 02:11:55 robbat2 Exp $
4 vapier 1.76
5     # @ECLASS: autotools.eclass
6     # @MAINTAINER:
7     # base-system@gentoo.org
8     # @BLURB: Regenerates auto* build scripts
9     # @DESCRIPTION:
10     # This eclass is for safely handling autotooled software packages that need to
11     # regenerate their build scripts. All functions will abort in case of errors.
12 azarah 1.1 #
13 azarah 1.11 # NB: If you add anything, please comment it!
14 azarah 1.1
15 flameeyes 1.37 inherit eutils libtool
16 azarah 1.11
17 vapier 1.76 # @ECLASS-VARIABLE: WANT_AUTOCONF
18     # @DESCRIPTION:
19     # The major version of autoconf your package needs
20 vapier 1.94 : ${WANT_AUTOCONF:=latest}
21 vapier 1.76
22     # @ECLASS-VARIABLE: WANT_AUTOMAKE
23     # @DESCRIPTION:
24     # The major version of automake your package needs
25 vapier 1.94 : ${WANT_AUTOMAKE:=latest}
26 flameeyes 1.63
27 robbat2 1.95 # @ECLASS-VARIABLE: _LATEST_AUTOMAKE
28     # @DESCRIPTION:
29     # CONSTANT!
30 flameeyes 1.96 # The latest major version/slot of automake available on each arch.
31 robbat2 1.95 # If a newer version is stable on any arch, and is NOT reflected in this list,
32     # then circular dependencies may arise during emerge @system bootstraps.
33     # Do NOT change this variable in your ebuilds!
34     _LATEST_AUTOMAKE='1.11 1.10'
35    
36 vapier 1.40 _automake_atom="sys-devel/automake"
37     _autoconf_atom="sys-devel/autoconf"
38 peper 1.55 if [[ -n ${WANT_AUTOMAKE} ]]; then
39 flameeyes 1.49 case ${WANT_AUTOMAKE} in
40 vapier 1.67 none) _automake_atom="" ;; # some packages don't require automake at all
41 flameeyes 1.86 # if you change the “latest” version here, change also autotools_run_tool
42 robbat2 1.95 # this MUST reflect the latest stable major version for each arch!
43 flameeyes 1.96 latest)
44     t=""
45     for v in ${_LATEST_AUTOMAKE} ; do
46 robbat2 1.95 t="${t} =sys-devel/automake-${v}*"
47     done
48 flameeyes 1.96 _automake_atom="|| ( ${t} )"
49 robbat2 1.95 unset t v
50     ;;
51 vapier 1.67 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
52 flameeyes 1.49 esac
53 vapier 1.64 export WANT_AUTOMAKE
54 flameeyes 1.48 fi
55    
56 vapier 1.45 if [[ -n ${WANT_AUTOCONF} ]] ; then
57 flameeyes 1.41 case ${WANT_AUTOCONF} in
58 vapier 1.67 none) _autoconf_atom="" ;; # some packages don't require autoconf at all
59     2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
60 flameeyes 1.86 # if you change the “latest” version here, change also autotools_run_tool
61 vapier 1.67 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.61" ;;
62 vapier 1.68 *) _autoconf_atom="INCORRECT-WANT_AUTOCONF-SETTING-IN-EBUILD" ;;
63 flameeyes 1.41 esac
64 vapier 1.64 export WANT_AUTOCONF
65 flameeyes 1.41 fi
66 vapier 1.93
67     AUTOTOOLS_DEPEND="${_automake_atom} ${_autoconf_atom}"
68     [[ ${CATEGORY}/${PN} != "sys-devel/libtool" ]] && AUTOTOOLS_DEPEND="${AUTOTOOLS_DEPEND} >=sys-devel/libtool-2.2.6b"
69 flameeyes 1.46 RDEPEND=""
70 vapier 1.93
71     # @ECLASS-VARIABLE: AUTOTOOLS_AUTO_DEPEND
72     # @DESCRIPTION:
73     # Set to 'no' to disable automatically adding to DEPEND. This lets
74     # ebuilds former conditional depends by using ${AUTOTOOLS_DEPEND} in
75     # their own DEPEND string.
76 vapier 1.94 : ${AUTOTOOLS_AUTO_DEPEND:=yes}
77 vapier 1.93 if [[ ${AUTOTOOLS_AUTO_DEPEND} != "no" ]] ; then
78     DEPEND=${AUTOTOOLS_DEPEND}
79     fi
80    
81 vapier 1.40 unset _automake_atom _autoconf_atom
82 azarah 1.11
83 vapier 1.76 # @ECLASS-VARIABLE: AM_OPTS
84     # @DESCRIPTION:
85     # Additional options to pass to automake during
86     # eautoreconf call.
87    
88     # @ECLASS-VARIABLE: AT_NOELIBTOOLIZE
89     # @DESCRIPTION:
90     # Don't run elibtoolize command if set to 'yes',
91     # useful when elibtoolize needs to be ran with
92     # particular options
93 azarah 1.16
94 cardoe 1.66 # XXX: M4DIR should be deprecated
95 vapier 1.76 # @ECLASS-VARIABLE: AT_M4DIR
96     # @DESCRIPTION:
97     # Additional director(y|ies) aclocal should search
98 vapier 1.94 : ${AT_M4DIR:=${M4DIR}}
99 azarah 1.16 AT_GNUCONF_UPDATE="no"
100    
101 azarah 1.11
102 vapier 1.76 # @FUNCTION: eautoreconf
103     # @DESCRIPTION:
104 azarah 1.17 # This function mimes the behavior of autoreconf, but uses the different
105     # eauto* functions to run the tools. It doesn't accept parameters, but
106     # the directory with include files can be specified with AT_M4DIR variable.
107 jmbsvicetto 1.81 #
108 vapier 1.76 # Should do a full autoreconf - normally what most people will be interested in.
109     # Also should handle additional directories specified by AC_CONFIG_SUBDIRS.
110 azarah 1.17 eautoreconf() {
111 vapier 1.91 local x auxdir g
112 jmbsvicetto 1.81
113 flameeyes 1.39 if [[ -z ${AT_NO_RECURSIVE} ]]; then
114     # Take care of subdirs
115     for x in $(autotools_get_subdirs); do
116     if [[ -d ${x} ]] ; then
117 vapier 1.91 pushd "${x}" >/dev/null
118 flameeyes 1.39 AT_NOELIBTOOLIZE="yes" eautoreconf
119 vapier 1.91 popd >/dev/null
120 flameeyes 1.39 fi
121     done
122     fi
123 azarah 1.11
124 flameeyes 1.38 auxdir=$(autotools_get_auxdir)
125    
126 vapier 1.91 einfo "Running eautoreconf in '${PWD}' ..."
127 flameeyes 1.38 [[ -n ${auxdir} ]] && mkdir -p ${auxdir}
128 azarah 1.17 eaclocal
129 grobian 1.83 [[ ${CHOST} == *-darwin* ]] && g=g
130     if ${LIBTOOLIZE:-${g}libtoolize} -n --install >& /dev/null ; then
131 vapier 1.72 _elibtoolize --copy --force --install
132     else
133     _elibtoolize --copy --force
134     fi
135 azarah 1.17 eautoconf
136     eautoheader
137 flameeyes 1.35 FROM_EAUTORECONF="yes" eautomake ${AM_OPTS}
138 azarah 1.1
139 flameeyes 1.32 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0
140    
141 flameeyes 1.30 # Call it here to prevent failures due to elibtoolize called _before_
142 vapier 1.84 # eautoreconf. We set $S because elibtoolize runs on that #265319
143 vapier 1.91 S=${PWD} elibtoolize
144 flameeyes 1.30
145 flameeyes 1.21 return 0
146 azarah 1.12 }
147    
148 vapier 1.76 # @FUNCTION: eaclocal
149     # @DESCRIPTION:
150 azarah 1.11 # These functions runs the autotools using autotools_run_tool with the
151     # specified parametes. The name of the tool run is the same of the function
152     # without e prefix.
153     # They also force installing the support files for safety.
154 vapier 1.76 # Respects AT_M4DIR for additional directories to search for macro's.
155 azarah 1.11 eaclocal() {
156 azarah 1.12 local aclocal_opts
157    
158 vapier 1.74 local amflags_file
159     for amflags_file in GNUmakefile.am Makefile.am GNUmakefile.in Makefile.in ; do
160     [[ -e ${amflags_file} ]] || continue
161     aclocal_opts=$(sed -n '/^ACLOCAL_AMFLAGS[[:space:]]*=/s:[^=]*=::p' ${amflags_file})
162 vapier 1.75 eval aclocal_opts=\"${aclocal_opts}\"
163 vapier 1.74 break
164     done
165    
166 azarah 1.16 if [[ -n ${AT_M4DIR} ]] ; then
167     for x in ${AT_M4DIR} ; do
168     case "${x}" in
169     "-I")
170     # We handle it below
171     ;;
172     *)
173     [[ ! -d ${x} ]] && ewarn "eaclocal: '${x}' does not exist"
174     aclocal_opts="${aclocal_opts} -I ${x}"
175     ;;
176     esac
177     done
178     fi
179 flameeyes 1.15
180 flameeyes 1.22 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
181 azarah 1.12 autotools_run_tool aclocal "$@" ${aclocal_opts}
182     }
183    
184 vapier 1.76 # @FUNCTION: _elibtoolize
185     # @DESCRIPTION:
186     # Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from
187     # libtool.eclass.
188 azarah 1.12 _elibtoolize() {
189 grobian 1.83 local opts g=
190 swegener 1.20
191 flameeyes 1.34 # Check if we should run libtoolize (AM_PROG_LIBTOOL is an older macro,
192     # check for both it and the current AC_PROG_LIBTOOL)
193 vapier 1.77 [[ -n $(autotools_check_macro AC_PROG_LIBTOOL AM_PROG_LIBTOOL LT_INIT) ]] || return 0
194 azarah 1.19
195 flameeyes 1.70 [[ -f GNUmakefile.am || -f Makefile.am ]] && opts="--automake"
196 swegener 1.20
197 grobian 1.83 [[ ${CHOST} == *-darwin* ]] && g=g
198     autotools_run_tool ${LIBTOOLIZE:-${g}libtoolize} "$@" ${opts}
199 flameeyes 1.15
200 azarah 1.12 # Need to rerun aclocal
201     eaclocal
202 azarah 1.11 }
203 azarah 1.1
204 vapier 1.76 # @FUNCTION: eautoheader
205     # @DESCRIPTION:
206     # Runs autoheader.
207 azarah 1.11 eautoheader() {
208 azarah 1.12 # Check if we should run autoheader
209     [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
210 flameeyes 1.58 NO_FAIL=1 autotools_run_tool autoheader "$@"
211 azarah 1.11 }
212 azarah 1.1
213 vapier 1.76 # @FUNCTION: eautoconf
214     # @DESCRIPTION:
215     # Runs autoconf.
216 azarah 1.11 eautoconf() {
217 azarah 1.12 if [[ ! -f configure.ac && ! -f configure.in ]] ; then
218     echo
219 vapier 1.91 eerror "No configure.{ac,in} present in '${PWD}'!"
220 azarah 1.12 echo
221     die "No configure.{ac,in} present!"
222     fi
223    
224 azarah 1.11 autotools_run_tool autoconf "$@"
225     }
226 azarah 1.1
227 vapier 1.76 # @FUNCTION: eautomake
228     # @DESCRIPTION:
229     # Runs automake.
230 azarah 1.11 eautomake() {
231 flameeyes 1.24 local extra_opts
232 flameeyes 1.70 local makefile_name
233 flameeyes 1.24
234 flameeyes 1.70 if [[ -f GNUmakefile.am ]]; then
235     makefile_name="GNUmakefile"
236     elif [[ -f Makefile.am ]]; then
237     makefile_name="Makefile"
238     else
239     return 0
240     fi
241 flameeyes 1.24
242 flameeyes 1.70 if [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name}.in ]]; then
243 flameeyes 1.35 local used_automake
244     local installed_automake
245    
246 vapier 1.87 installed_automake=$(WANT_AUTOMAKE= automake --version | head -n 1 | \
247 flameeyes 1.35 sed -e 's:.*(GNU automake) ::')
248 flameeyes 1.70 used_automake=$(head -n 1 < ${makefile_name}.in | \
249 flameeyes 1.35 sed -e 's:.*by automake \(.*\) from .*:\1:')
250    
251     if [[ ${installed_automake} != ${used_automake} ]]; then
252     einfo "Automake used for the package (${used_automake}) differs from"
253     einfo "the installed version (${installed_automake})."
254     eautoreconf
255 flameeyes 1.36 return 0
256 flameeyes 1.35 fi
257     fi
258    
259 flameeyes 1.33 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS ]] \
260 flameeyes 1.24 || extra_opts="${extra_opts} --foreign"
261    
262 flameeyes 1.14 # --force-missing seems not to be recognized by some flavours of automake
263 flameeyes 1.24 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
264 azarah 1.1 }
265    
266 vapier 1.90 # @FUNCTION: eautopoint
267     # @DESCRIPTION:
268     # Runs autopoint (from the gettext package).
269     eautopoint() {
270     autotools_run_tool autopoint "$@"
271     }
272    
273 azarah 1.17 # Internal function to run an autotools' tool
274     autotools_run_tool() {
275 jmbsvicetto 1.81 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
276 flameeyes 1.71 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase"
277     fi
278    
279 flameeyes 1.86 # We do the “latest” → version switch here because it solves
280     # possible order problems, see bug #270010 as an example.
281 flameeyes 1.96 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
282     for pv in ${_LATEST_AUTOMAKE} ; do
283     has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="$pv"
284     done
285     unset pv
286     [[ ${WANT_AUTOMAKE} == "latest" ]] && \
287     die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}"
288     fi
289 flameeyes 1.86 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
290    
291 vapier 1.85 local STDERR_TARGET="${T}/$1.out"
292     # most of the time, there will only be one run, but if there are
293     # more, make sure we get unique log filenames
294     if [[ -e ${STDERR_TARGET} ]] ; then
295     STDERR_TARGET="${T}/$1-$$.out"
296     fi
297 azarah 1.17
298 vapier 1.85 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}"
299 azarah 1.17
300 azarah 1.27 ebegin "Running $@"
301 vapier 1.85 "$@" >> "${STDERR_TARGET}" 2>&1
302     eend $?
303 azarah 1.17
304 vapier 1.85 if [[ $? != 0 && ${NO_FAIL} != 1 ]] ; then
305 azarah 1.17 echo
306     eerror "Failed Running $1 !"
307     eerror
308     eerror "Include in your bugreport the contents of:"
309     eerror
310 vapier 1.85 eerror " ${STDERR_TARGET}"
311 azarah 1.17 echo
312     die "Failed Running $1 !"
313     fi
314     }
315    
316     # Internal function to check for support
317     autotools_check_macro() {
318 vapier 1.77 [[ -f configure.ac || -f configure.in ]] || return 0
319     local macro
320     for macro ; do
321     WANT_AUTOCONF="2.5" autoconf --trace="${macro}" 2>/dev/null
322     done
323 azarah 1.17 return 0
324     }
325    
326     # Internal function to get additional subdirs to configure
327     autotools_get_subdirs() {
328     local subdirs_scan_out
329    
330     subdirs_scan_out=$(autotools_check_macro "AC_CONFIG_SUBDIRS")
331     [[ -n ${subdirs_scan_out} ]] || return 0
332    
333     echo "${subdirs_scan_out}" | gawk \
334     '($0 !~ /^[[:space:]]*(#|dnl)/) {
335 azarah 1.25 if (match($0, /AC_CONFIG_SUBDIRS:(.*)$/, res))
336     print res[1]
337 azarah 1.17 }' | uniq
338 azarah 1.16
339 azarah 1.17 return 0
340 azarah 1.11 }
341 azarah 1.17
342 flameeyes 1.38 autotools_get_auxdir() {
343     local auxdir_scan_out
344    
345     auxdir_scan_out=$(autotools_check_macro "AC_CONFIG_AUX_DIR")
346     [[ -n ${auxdir_scan_out} ]] || return 0
347    
348     echo ${auxdir_scan_out} | gawk \
349     '($0 !~ /^[[:space:]]*(#|dnl)/) {
350     if (match($0, /AC_CONFIG_AUX_DIR:(.*)$/, res))
351     print res[1]
352     }' | uniq
353    
354     return 0
355 vapier 1.40 }

  ViewVC Help
Powered by ViewVC 1.1.20